.DEVICE AT90S1200
;
;   ( UA4NM )
;
;
;   CW  - 3.0 ,  - 3.1",
;  - 3.5 ,  - 3.4
;  - 4 
;
.CSEG;   
;____________________________________________________________________
         LDI R20,0x0F
         OUT 0x21,R20         ;    2 .
         CLR R7               ;  R7
         OUT 0x3B,R7          ;    .
         OUT 0x8,R7           ;  .  .  .
         OUT 0x17,R7          ;  P1.0 - P1.7 -> 
         LDI R20,0xFF
         OUT 0x11,R20         ;  P3.0-P3.7 -> 
         OUT 0x12,R7          ;  D 
;********************************************************************
;  
;********************************************************************
; Tone UA4NM QRA LO48UM TX 3 watt Ant GP
;
beacon:  SBI 0x12,0           ;  Port P3.0  "1"
         CBI 0x12,1           ;  Port P3.1  "0"
         SBI 0x12,5           ;  Port P3.5  "1"
         LDI R20,0x70         ;  
T2:      rcall SOUND
         DEC R20 
         BRNE T2              ;  32 .
         SBI 0x12,1           ;  Port P3.1  "1"
         CBI 0x12,0           ;  Port P3.0  "0"
         CBI 0x12,5           ;  Port P3.5  "0"
START:   RCALL PAUSA3
         RCALL PAUSA2
         RCALL tochka         ; U
         RCALL tochka
         RCALL tire
         RCALL PAUSA1
         RCALL tochka         ; A
         RCALL tire
         RCALL PAUSA1
         RCALL tochka         ; 4
         RCALL tochka
         RCALL tochka
         RCALL tochka
         RCALL tire
         RCALL PAUSA1
         RCALL tire           ; N
         RCALL tochka
         RCALL PAUSA1
         RCALL tire           ; M
         RCALL tire
         RCALL PAUSA2
         RCALL PAUSA3
         RCALL tire           ; Q
         RCALL tire
         RCALL tochka
         RCALL tire
         RCALL PAUSA1
         RCALL tire           ; T
         RCALL PAUSA1
         RCALL tochka         ; H
         RCALL tochka
         RCALL tochka
         RCALL tochka
         RCALL PAUSA2
         RCALL tochka         ; I
         RCALL tochka
         RCALL PAUSA1
         RCALL tochka         ; S
         RCALL tochka
         RCALL tochka
         RCALL PAUSA2
         RCALL tire           ; K
         RCALL tochka
         RCALL tire
         RCALL PAUSA1
         RCALL tochka         ; I
         RCALL tochka
         RCALL PAUSA1
         RCALL tochka         ; R
         RCALL tire
         RCALL tochka
         RCALL PAUSA1
         RCALL tire           ; O
         RCALL tire
         RCALL tire
         RCALL PAUSA1
         RCALL tochka         ; V
         RCALL tochka
         RCALL tochka
         RCALL tire
         RCALL PAUSA3
         RCALL tire           ; Q
         RCALL tire
         RCALL tochka
         RCALL tire
         RCALL PAUSA1
         RCALL tochka         ; R
         RCALL tire
         RCALL tochka
         RCALL PAUSA1
         RCALL tochka         ; A
         RCALL tire
         RCALL PAUSA2
         RCALL tochka         ; I
         RCALL tochka
         RCALL PAUSA1
         RCALL tochka         ; S
         RCALL tochka
         RCALL tochka
         RCALL PAUSA2
         RCALL tochka         ; L
         RCALL tire
         RCALL tochka
         RCALL tochka
         RCALL PAUSA1
         RCALL tire           ; O
         RCALL tire
         RCALL tire
         RCALL PAUSA1
         RCALL tochka         ; 4
         RCALL tochka
         RCALL tochka
         RCALL tochka
         RCALL tire
         RCALL PAUSA1
         RCALL tire           ; 8
         RCALL tire
         RCALL tire
         RCALL tochka
         RCALL tochka
         RCALL PAUSA1
         RCALL tochka         ; U
         RCALL tochka
         RCALL tire
         RCALL PAUSA1
         RCALL tire           ; O
         RCALL tire
         RCALL tire
         RCALL PAUSA3
         RCALL tire           ; T
         RCALL PAUSA1
         RCALL tire           ; X
         RCALL tochka
         RCALL tochka
         RCALL tire
         RCALL PAUSA2
         RCALL tochka         ; 2
         RCALL tochka
         RCALL tire
         RCALL tire
         RCALL tire
         RCALL PAUSA2
         RCALL tochka         ; W
         RCALL tire
         RCALL tire
         RCALL PAUSA1
         RCALL tochka         ; A
         RCALL tire
         RCALL PAUSA1
         RCALL tire           ; T
         RCALL PAUSA1
         RCALL tire           ; T
         RCALL PAUSA1
         RCALL tochka         ; S
         RCALL tochka
         RCALL tochka
         RCALL PAUSA3 
         RCALL tochka         ; A
         RCALL tire
         RCALL PAUSA1
         RCALL tire           ; N
         RCALL tochka
         RCALL PAUSA1
         RCALL tire           ; T
         RCALL PAUSA2
         RCALL tire           ; G
         RCALL tire 
         RCALL tochka
         RCALL PAUSA1
         RCALL tochka         ; P
         RCALL tire
         RCALL tire 
         RCALL tochka
         RCALL PAUSA3
         rjmp BEACON
;********************************************************************
;
;  , , , 1, 2, 
;
;********************************************************************
tochka:  
         SBI 0x12,0           ;  Port P3.0  "1"
         CBI 0x12,1           ;  Port P3.1  "0"
         SBI 0x12,5           ;  Port P3.5  "1"
         rcall SOUND
         SBI 0x12,1           ;  Port P3.1  "1"
         CBI 0x12,0           ;  Port P3.0  "0"
         CBI 0x12,5           ;  Port P3.5  "0"
         rcall PAUSA
         RET
;_____________________________________________
tire:    
         SBI 0x12,0           ;  Port P3.0  "1"
         CBI 0x12,1           ;  Port P3.1  "0"
         SBI 0x12,5           ;  Port P3.5  "1"
         rcall SOUND
         rcall SOUND
         rcall SOUND
         LDI R19,0x27         ; 
         rcall S1
         SBI 0x12,1           ;  Port P3.1  "1"
         CBI 0x12,0           ;  Port P3.0  "0"
         CBI 0x12,5           ;  Port P3.5  "0"
         rcall PAUSA
         RET
;_____________________________________________
pausa:   
         LDI R19,0x80         ;  
P1:      LDI R21,0xFF
P2:      WDR
         WDR
         WDR
         DEC R21
         BRNE P2              ;  FF .
         LDI R21,0xFF
P3:      WDR
         WDR
         WDR 
         DEC R21
         BRNE P3              ;  FF .
         DEC R19
         BRNE P1              ;  FF .
         RET
;_____________________________________________
PAUSA1:  LDI R19,0xFF         ;  2 
         rjmp P1              ;      ( 2 + 1  )
;_____________________________________________
PAUSA2:  LDI R19,0xFF         ;  2 
         RCALL P1             ;    ( 6 + 1  )
         LDI R19,0xFF         ;  2 
         RCALL P1
         RET
;_____________________________________________
PAUSA3:  
         RCALL pausa2         ;    ( 12 +1  )
         RCALL pausa2 
         RET
;_____________________________________________
SOUND:   LDI R19,0x70         ;  
S1:      LDI R21,0xFF
S2:      WDR
         SBI 0x12,4           ;  Port P3.4  "1"
         DEC R21
         BRNE S2              ;  FF .
         LDI R21,0xFF
S3:      WDR
         CBI 0x12,4           ;  Port P3.4  "0"
         DEC R21
         BRNE S3              ;  FF .
         DEC R19
         BRNE S1              ;  FF .
         ret
